diff mbox series

[v2,16/16] generic: add race test that mmap write to target of reflink

Message ID 20211125074752.274176-17-ruansy.fnst@fujitsu.com (mailing list archive)
State New, archived
Headers show
Series generic: add some mmap CoW tests | expand

Commit Message

Shiyang Ruan Nov. 25, 2021, 7:47 a.m. UTC
Test for races or FS corruption when mmap writing to a file that's also
the target of a reflink operation. (MMAP version of generic/168,170)

Signed-off-by: Shiyang Ruan <ruansy.fnst@fujitsu.com>
---
 tests/generic/915     | 64 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/915.out |  4 +++
 2 files changed, 68 insertions(+)
 create mode 100755 tests/generic/915
 create mode 100644 tests/generic/915.out

Comments

Darrick J. Wong Dec. 7, 2021, 12:27 a.m. UTC | #1
On Thu, Nov 25, 2021 at 03:47:52PM +0800, Shiyang Ruan wrote:
> Test for races or FS corruption when mmap writing to a file that's also
> the target of a reflink operation. (MMAP version of generic/168,170)
> 
> Signed-off-by: Shiyang Ruan <ruansy.fnst@fujitsu.com>

Looks pretty straightforward,
Reviewed-by: Darrick J. Wong <djwong@kernel.org>

--D

> ---
>  tests/generic/915     | 64 +++++++++++++++++++++++++++++++++++++++++++
>  tests/generic/915.out |  4 +++
>  2 files changed, 68 insertions(+)
>  create mode 100755 tests/generic/915
>  create mode 100644 tests/generic/915.out
> 
> diff --git a/tests/generic/915 b/tests/generic/915
> new file mode 100755
> index 00000000..365f304c
> --- /dev/null
> +++ b/tests/generic/915
> @@ -0,0 +1,64 @@
> +#! /bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +#
> +# FS QA Test No. 915
> +#
> +# Test for races or FS corruption when mmap writing to a file that's also
> +# the target of a reflink operation. (MMAP version of generic/168,170)
> +#
> +. ./common/preamble
> +_begin_fstest auto clone
> +
> +_register_cleanup "_cleanup" BUS
> +
> +# Import common functions.
> +. ./common/filter
> +. ./common/reflink
> +
> +# real QA test starts here
> +_require_scratch_reflink
> +
> +echo "Format and mount"
> +_scratch_mkfs > $seqres.full 2>&1
> +_scratch_mount >> $seqres.full 2>&1
> +
> +testdir=$SCRATCH_MNT/test-$seq
> +finished_file=/tmp/finished
> +rm -rf $finished_file
> +mkdir $testdir
> +
> +loops=1024
> +nr_loops=$((loops - 1))
> +blksz=65536
> +
> +echo "Initialize files"
> +echo >> $seqres.full
> +_pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
> +_pwrite_byte 0x62 0 $((loops * blksz)) $testdir/file2 >> $seqres.full
> +_scratch_cycle_mount
> +
> +# mmap overwriter...
> +overwrite() {
> +	while [ ! -e $finished_file ]; do
> +		seq $nr_loops -1 0 | while read i; do
> +			$XFS_IO_PROG -f -c "mmap -rw $((i * blksz)) $blksz" \
> +				-c "mwrite -S 0x63 $((i * blksz)) $blksz" $testdir/file2 >> $seqres.full
> +		done
> +	done
> +}
> +
> +echo "Reflink and mmap write the target"
> +overwrite &
> +seq 1 10 | while read j; do
> +	seq 0 $nr_loops | while read i; do
> +		_reflink_range  $testdir/file1 $((i * blksz)) \
> +				$testdir/file2 $((i * blksz)) $blksz >> $seqres.full
> +		[ $? -ne 0 ] && exit
> +	done
> +done
> +touch $finished_file
> +wait
> +
> +# success, all done
> +status=0
> +exit
> diff --git a/tests/generic/915.out b/tests/generic/915.out
> new file mode 100644
> index 00000000..4e77847b
> --- /dev/null
> +++ b/tests/generic/915.out
> @@ -0,0 +1,4 @@
> +QA output created by 915
> +Format and mount
> +Initialize files
> +Reflink and mmap write the target
> -- 
> 2.34.0
> 
> 
>
diff mbox series

Patch

diff --git a/tests/generic/915 b/tests/generic/915
new file mode 100755
index 00000000..365f304c
--- /dev/null
+++ b/tests/generic/915
@@ -0,0 +1,64 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+#
+# FS QA Test No. 915
+#
+# Test for races or FS corruption when mmap writing to a file that's also
+# the target of a reflink operation. (MMAP version of generic/168,170)
+#
+. ./common/preamble
+_begin_fstest auto clone
+
+_register_cleanup "_cleanup" BUS
+
+# Import common functions.
+. ./common/filter
+. ./common/reflink
+
+# real QA test starts here
+_require_scratch_reflink
+
+echo "Format and mount"
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount >> $seqres.full 2>&1
+
+testdir=$SCRATCH_MNT/test-$seq
+finished_file=/tmp/finished
+rm -rf $finished_file
+mkdir $testdir
+
+loops=1024
+nr_loops=$((loops - 1))
+blksz=65536
+
+echo "Initialize files"
+echo >> $seqres.full
+_pwrite_byte 0x61 0 $((loops * blksz)) $testdir/file1 >> $seqres.full
+_pwrite_byte 0x62 0 $((loops * blksz)) $testdir/file2 >> $seqres.full
+_scratch_cycle_mount
+
+# mmap overwriter...
+overwrite() {
+	while [ ! -e $finished_file ]; do
+		seq $nr_loops -1 0 | while read i; do
+			$XFS_IO_PROG -f -c "mmap -rw $((i * blksz)) $blksz" \
+				-c "mwrite -S 0x63 $((i * blksz)) $blksz" $testdir/file2 >> $seqres.full
+		done
+	done
+}
+
+echo "Reflink and mmap write the target"
+overwrite &
+seq 1 10 | while read j; do
+	seq 0 $nr_loops | while read i; do
+		_reflink_range  $testdir/file1 $((i * blksz)) \
+				$testdir/file2 $((i * blksz)) $blksz >> $seqres.full
+		[ $? -ne 0 ] && exit
+	done
+done
+touch $finished_file
+wait
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/915.out b/tests/generic/915.out
new file mode 100644
index 00000000..4e77847b
--- /dev/null
+++ b/tests/generic/915.out
@@ -0,0 +1,4 @@ 
+QA output created by 915
+Format and mount
+Initialize files
+Reflink and mmap write the target